-- Déclaration avancée de fonctions locales
local single_page, read_file, urldecode, read_directory

-- Boucle principale du programme
local function main_server(root, port)
  local socket = require 'socket'
  root = root or "/var/www"
  local server = socket.bind("0.0.0.0", port or 8080)
  while true do
    local client = server:accept()
    local res, err = xpcall(single_page, 
      debug.traceback, client, root)
    if not res then
      -- Si une erreur s'est produite, renvoyer code HTTP 500
      client:send"HTTP/1.0 500 Internal Server Error\r\n\r\n"
      client:send("OUPS! Il doit y avoir un bogue :\r\n"..err)
    end
    client:close()
  end
end

-- Fonction appelée pour chaque requête à servir
function single_page(client, root)
  -- Lit et interprète la 1ère ligne de la requête
  local line = assert(client:receive())
  local verb, path, proto = 
    assert(line:match("([A-Z]+)%s+(%S+)%s+(HTTP.+)"))
  -- Décode les lignes d'en-tête de la requête
  local request = {}
  repeat
    line = assert(client:receive())
    local param, value = line:match("(%S-)%s*:%s*(.*)")
    if param then
      request[param] = value
    end
  until line == ""
  -- Provisoire: renvoie l'en-tête au client
  for k,v in pairs(request) do
    client:send(k.." = "..v.."\n")
  end
end

-- Lance le serveur avec les arguments passés au script
main_server(...)
