function deep_find(path, filter)
  local lfs = require 'lfs'
  local function find(path)
    for f in lfs.dir(path) do
      if f == '.' or f == '..' then goto continue end
      f = path..f
      local mode = lfs.attributes(f, 'mode')
      if not mode then goto continue end
      if mode == 'directory' then
        f = f .. '/'
      end
      if f:match(filter) then
        coroutine.yield(f, mode)
      end
      if mode == 'directory' then
        find(f)
      end
    ::continue:: 
    end
  end
  filter = filter or ''
  path = (path or '.'):gsub("[^/]$","%1/")
  return coroutine.wrap(function() find(path) end)
end

for f in deep_find(".", "%.lua$") do
  print(f)
end