print "___________________________________"
-- Charge la librairie et l'assigne  m
local m = require"lpeg"

-- Affiche la version de la librairie, ici 0.10
print("LPeg version: " .. m.version())

local s = "alpha"
print(m.match("", s)) --> 1
print(m.match("", s, 3))
--> 3 (la chane vide est trouve partout)
print(m.match("a", s)) --> 2
print(m.match("a", s, 3))
--> nil (ancr  l'index donn, ne trouve pas le second a)
print(m.match(1, s))
--> 2 (position aprs avoir trouv un caractre)
print(m.match(10, s))
--> nil (n'a pas trouv 10 caractres)
print(m.match(true, s))
--> 1 (concide toujours, sans consommer l'entre)
print(m.match(false, s))
--> nil (ne concide jamais)
print "___________________________________"

-- J'exploite le raccourci syntaxique f("x") == f"x"
local s1 = m.S"aeiou"
local s2 = m.S"02468"

print(s1:match("alpha"))    --> 2
print(s1:match("alpha", 3)) --> nil
print(s2:match("b52", 3))   --> 4
print(s2:match("b52", 2))   --> nil

local r1 = m.R"az"
local r2 = m.R"90"
print(r1:match("alpha"))   --> 2
print(r1:match("Beta"))    --> nil (sensible  la casse
print(r2:match("UB40", 4)) --> nil (intervalle invalide)
print "___________________________________"

local t = m.locale()

local test = "abcABC789z"
print(m.match(t.alpha^1, test))     --> 7  (arrt sur 7)
print(m.match(t.alnum^1, test))     --> 11 (fin de chane)
print(m.match(t.digit^1, test, 7))  --> 10 (arrt sur z)
print(m.match(t.lower^1, test))     --> 4  (arrt sur A)
print(m.match(t.upper^1, test, 4))  --> 7  (arrt sur 7)
print(m.match(t.xdigit^1, test))    --> 10 (arrt sur z)

local test = "ab:- \r\n @ \b\r!"
print(m.match(t.graph^1, test))     --> 5  (arrt sur l'espace)
print(m.match(t.print^1, test))     --> 6  (arrt sur l'espace)
print(m.match(t.cntrl^1, test, 6))  --> 8  (arrt sur l'espace)
print(m.match(t.cntrl^1, test, 11)) --> 13 (arrt sur !)
print(m.match(t.space^1, test, 5))  --> 9  (arrt sur @)
print(m.match(t.space^1, test, 10)) --> 11 (arrt sur \b)
print(m.match(t.punct^1, test, 3))  --> 5  (arrt sur l'espace)
print "___________________________________"

local s1 = m.S"aeiou"
local s2 = m.S"02468"
local r1 = m.R"az"

print(m.match(s1^2, "alpha"))
--> nil (pas assez de caractres concidant)
print(m.match(s2^2, ""))      --> nil
print(m.match(s1^2, "oubli")) --> 3
print(m.match(s2^2, "2048"))  --> 5
print(m.match(s2^2, ""))      --> nil

print(m.match(r1^-2, "alpha"))
--> 3 (ne va pas plus loin que 2 concidences)
print(m.match(r1^-2, "z"))
--> 2 (content avec moins)
print(m.match(r1^-2, ""))
--> 1 (concide avec la chane vide)
print(m.match(r1^-2, "Beta"))
--> 1 (accepte zro concidence)
print "___________________________________"

local digit = m.R'09'
-- Pas de rptition  un nombre exact, on le fait  la main
local digit2 = digit * digit
local digit4 = digit2 * digit2
local dash = '-'
local dateAnsi = digit4 * dash * digit2 * dash * digit2
print(dateAnsi:match"2012-05-12")  --> 11
print(dateAnsi:match"12/05/2012")  --> nil
print(dateAnsi:match"102/05/2012") --> nil
-- Ou
local yearP = digit4
local monthP = digit2
local dayP = digit2
local dateAnsi = yearP * dash * monthP * dash * dayP
local dateEurop = dayP * '/' * monthP * '/' * yearP
print(dateAnsi:match"2012-05-12")   --> 11
print(dateEurop:match"12/05/2012")  --> 11
print(dateEurop:match"12/105/2012") --> nil
print "___________________________________"

local toSearch =
  "La Bastille fut prise le 14/07/1789 lors de la Rvolution."
local d = m.R'09'
local dds = d * d * '/'
local dateFr = dds * dds * d * d * d * d

for i = 1, #toSearch do
  if dateFr:match(toSearch, i) ~= nil then
    print("Found at " .. i) --> Found at 26
    break
  end
end
print "___________________________________"

-- Fonction prenant un motif et le transformant
-- de sorte qu'il cherche n'importe o dans une chane
function matchAnywhere(p)
  return
      -- Concide avec tout caractre
      -- tant qu'on n'a pas trouv le motif
      (1 - m.P(p))^0
      -- Jusqu' ce qu'on trouve le motif
      * p
end

if matchAnywhere(dateFr):match(toSearch) ~= nil then
  print("Found!")
end
print "___________________________________"


local slash = '/'
-- Tout chiffre
local digit = m.R'09'

-- Les sicles accepts
-- 16  19 OU 2x  9x
local century = '1' * m.R'69' + m.R'29' * digit
-- N'importe quelle anne dans l'intervalle fix
local anyYear = century * digit * digit -- Suivi de deux chiffres

-- Mois de 01  12
local anyMonth = '0' * m.R'19' + '1' * m.R'02'
-- Les 28 premiers jours
local anyDay28 = '0' * m.R'19' + '1' * digit + '2' * m.R'08'
-- Une date est toujours valide dans les 28 premiers jours
local anyDate28Days=anyDay28 * slash * anyMonth * slash * anyYear

-- Les jours et mois de 29 ou 30 jours
local thirtyDayMonth = (m.P'29' + m.P'30') -- 29 ou 30 jours
    * slash *
    -- Suivi de mois ayant 30 jours (tous sauf fvrier)
    (anyMonth - '02')

-- Les jours et mois de 31 jours
local thirtyOneDayMonth = m.P'31' -- 31 jours
    * slash * -- Suivi de mois ayant 31 jours
    ('0' * (m.S'13578') -- 01 03 ... 08
      + '10' + '12') -- Ou 10 ou 12

local february29 = '29/02/'
-- Les annes bissextiles sont celles
-- o l'anne est divisible par quatre,
-- sauf les multiples de 100, sauf les multiples de 400
-- Multiples de 4: le nombre fait avec les deux derniers chiffres
-- est divisible par 4
-- Table de 4 rpartie en deux groupes :
-- 00 04 08 | 12 16
-- 20 24 28 | 32 36
-- 40 44 48 | 52 56
-- 60 64 68 | 72 76
-- 80 84 88 | 92 96
local multiple4=(m.S'02468' * m.S'048') + (m.S'13579' * m.S'26')
local leapYears = century * multiple4
-- Multiples de 100
local year100 = century * '00'
-- Multiples de 400: 1600, 2000, 2400, etc.
-- Sous-ensemble de multiple4
local year400 = ('16' +
    m.S'2468' * m.S'048' + m.S'3579' * m.S'26') * '00'
local realLeapYear = year400 + (leapYears - year100)

-- Une date est correcte si elle a 28 jours,
-- ou si c'est une date valide  30 ou 31 jours,
-- ou si c'est un 29 fvrier valide
local correctDate = (anyDate28Days +
    (thirtyDayMonth + thirtyOneDayMonth) * slash * anyYear +
    february29 * realLeapYear) * -1
    -- Le -1 quivaut au $ en ER,
    -- c'est--dire qu'il assure qu'on est en fin de chane

-- Test

local goodDates =
{
  "12/05/2012",
  "01/01/1912",
  "28/12/3987",
  "01/01/1600",
  "30/11/4567",
  "31/12/9999",
  "29/02/1600",
  "29/02/2000",
  "29/02/2012",
  "06/10/2961",
}

local badDates =
{
  "12/05/1012",
  "01/13/1912",
  "00/02/2012",
  "31/11/5912",
  "29/02/3987",
  "29/02/1700",
  "29/02/1900",
  "29/02/2013",
  "30/02/2012",
  "06/10/19610",
}

-- Droulement des tests. Ne doit rien afficher...
for n, date in ipairs(goodDates) do
  if correctDate:match(date) ~= 11 then
    print("Bad match: " .. date)
  end
end
for n, date in ipairs(badDates) do
  if correctDate:match(date) ~= nil then
    print("Bad match: " .. date)
  end
end
print "___________________________________"

-- Un chiffre ou plus
local digits = m.R"09"^1
-- Des lettres (ou pas)
local letters = m.R"az"^0
-- Capture au moins un chiffre
local getDigits = m.C(digits)
-- Lettres suivies de chiffres  capturer
local p = letters * getDigits
print(p:match"hello42 foo") --> 42

-- Capture les chiffres d'une rfrence
local refNb = "LUA-" * getDigits
print(refNb:match"LUA-1993 is our new product") --> 1993
-- Capture une rfrence entre guillemets
local quotedRef = m.C('"' * refNb * '"')
-- Saute tout caractre autre que guillemet
local findRef = (1 - m.P'"')^0
    -- jusqu' trouver une rfrence entre guillemets
    * quotedRef
print(findRef:match[[La rfrence "LUA-1993" est disponible]])
--> "LUA-1993"  1993
-- Soit la rfrence entre guillemets,
-- et la capture interne, le numro de rfrence
print "___________________________________"

-- digits et letters dfinis plus haut
-- Capture position
local P = m.Cp()
-- Lettres suivies de chiffres,
-- capture les positions (dbut et fin) des chiffres
local p = letters * P * digits * P
local subject = "something31415more"
local p1, p2 = p:match(subject)
local d = subject:sub(p1, p2-1)
print(d) --> 31415
print "___________________________________"

print(matchAnywhere(m.C(dateFr) * m.Cp()):match(toSearch))
--> 1789-07-14  36
print(matchAnywhere(m.C(dateFr) * m.Cp()):match("Bla"))
--> nil
print "___________________________________"

function captureAnywhere(p)
  -- Concide avec le motif et le capture,
  -- ou sinon avance d'un caractre, et recommence
  return (m.C(p) + 1)^0
end
print(captureAnywhere(dateFr * m.Cp()):match(toSearch))
--> 14/07/1789  36 (comme l'autre)
print(captureAnywhere(dateAnsi * m.Cp()):match("Bla"))
--> 4 (attention, a concid avec les caractres de la chane,
--  mais n'a rien captur)
print(captureAnywhere(dateAnsi * m.Cp()):match(""))
--> 1 (concide avec la chane vide...)
print(type(captureAnywhere(dateFr):match(toSearch)))
--> string (capture relle)
print(type(captureAnywhere(dateAnsi):match("Bla")))
--> number (match sans capture)

local consts = m.Cc("Add captures", "<<") * findRef * m.Cc(">>")
local ref = [[La rfrence "LUA-2011" est disponible]]
print(consts:match(ref))
--> Add captures  <<  "LUA-2011"  2011  >>

-- Les \r et \n ne sont pas interprts dans cette chane
-- littrale. Nous allons les restaurer.
local test=[[Multi\nline\rstrings\r\ninterpretation\n\\escaped\x]]
local backslash = m.P'\\'
local cr = m.P"\\r" -- Carriage return = retour chariot
local lf = m.P"\\n" -- Line feed = retour  la ligne
local toLines =
(
  (
    -- Si squence \r,
    -- capture le caractre de contrle correspondant
    cr * m.Cc"\r" +
    -- Idem pour la squence \n
    lf * m.Cc"\n" +
    -- Si simple backslash, le capture littralement
    m.C(backslash)
  )^1 -- en nombre quelconque
  -- Ou capture d'une squence sans backslash
  + m.C((1 - backslash)^1)
)^0 -- Rincer et rpter
-- Met le rsultat dans une table
local res = { toLines:match(test) }
-- Attention, CR peut cacher une partie des chanes sur la
-- console, il vaut mieux rediriger les rsultats sur un fichier
print(">>" .. table.concat(res) .. "<<")
-- Ajouter un sparateur, ventuellement: table.concat(res, '#')
print "___________________________________"

local args = m.Carg(1) * findRef * m.Carg(2)
print(args:match(ref, 1, "One", "Two"))
--> One  "LUA-2011"  2011  Two
print "___________________________________"

local cap = m.R'AZ'
-- Tout caractre non majuscule ou une maj. capture, rpt
local caps = ((1 - cap) + m.C(cap))^0
local acrostiche = m.Cf(caps, function (accu, letter)
  -- Ajoute les lettres majuscules les unes derrire les autres
  return accu .. letter
end)
print(acrostiche:match([[
Langage rapide et puissant,
Universel et plaisant,
Aimable mme]]))
-- Devinez le rsultat !
print "___________________________________"

local cap = m.R'AZ'
local ab = m.S'<>'
-- On peut ter plusieurs ensembles d'un ensemble
local capsNoAB = ((1 - cap - ab) + m.C(cap))^0
local patt =
      m.Cg(ab^0, 'equals') -- Capture, sans rsultat retourn
    * m.Cg(capsNoAB, 'caps') -- Idem
    * m.Cp() -- Position courante
    * m.Cb'caps' -- Restitue la capture des capitales
    * m.Cb'equals' -- Restitue la capture des signes gal
    * m.C(ab^0) -- Capture les derniers signes
print(patt:match(">>> Killing In The Name <<<"))
--> 25  K  I  T  N  >>>  <<<
print "___________________________________"

local cap = m.R'AZ'
local caps = ((1 - cap) + m.C(cap))^0
local toMatch =
  "Everybody's Got Something to Hide Except Me and My Monkey"
local t = m.Ct(caps):match(toMatch)
print(t) --> table: 0064D590
print(table.concat(t, '.')) --> E.G.S.H.E.M.M.M

local capsNoEqs = ((1 - cap - '=') + m.C(cap))^0
local eq = m.P'='^0
local patt = m.Cg(eq, 'equals') * capsNoEqs * m.Cp() *
    m.Cg(eq, 'equals')
local t = m.Ct(patt):match("====" .. toMatch .. "==")
print(table.concat(t, '.')) --> E.G.S.H.E.M.M.M.62
print(t.equals) --> ==
print "___________________________________"


local requestString = "http://www.example.com:8080/\z
  cgi/request.cgi?foo=bar&boolean&ltuae=42&stuff=some+words%21"
local loc = m.locale()
local skipToRequest = (1 - m.P'?')^0 * '?'
-- Pour simplifier, on n'accepte que les noms commenant
-- avec une lettre, et faits de lettres, chiffres,
-- tirets, souligns et points. La norme est moins restrictive.
local name = m.C(loc.alpha * (loc.alnum + m.S'-_.')^0)
-- Volontairement restrictif aussi
local value = m.C((loc.alnum + m.S'-_.%+')^0)
-- Le sparateur de paires peut tre & ou ;
local sepPairs = m.S'&;'
local sepNV = m.P'='
-- Un nom, suivi soit d'un sparateur et d'une valeur, soit de
-- rien du tout (la valeur est alors la constante chane vide),
-- sous forme de deux captures groupes anonymement,
-- suivi ventuellement d'un sparateur de paire
local pair = m.Cg(name * (sepNV * value + m.Cc'')) * sepPairs^-1
-- La requte : on saute l'URL
local request = skipToRequest
    -- On plie les captures,
    * m.Cf(
        -- Avec pour valeur initiale (premire capture) une table
        -- (cre par une capture de table sur une chane vide)
        m.Ct''
        -- et toutes les paires captures
        * pair^0,
        -- la fonction de pliage tant rawset,
        -- qui aura donc en paramtres  la table (accumulateur),
        -- et la capture groupe, cl, valeur
        rawset)
local requestPairs = request:match(requestString)
for k, v in pairs(requestPairs) do print(k, v) end
--[[ Rsultat :
stuff  some+words%21
ltuae  42
boolean
foo  bbar]]
print "___________________________________"

local properties =
[[
tabsize=8
  indent.size   =8
use.tabs= 1
colour.number =  fore:#007F7F

line_eq =   y = a * x + b
A42: LtUaE
]]
-- Espaces optionels
local spaces = loc.space^0
-- Retour  la ligne
local newLine = m.S'\r\n'
-- Les paires sont spares par des caractres de fin de ligne.
local sepPairs = newLine^1
-- Le sparateur entre nom et valeur peut tre = ou :
-- avec des espaces autour
local sepNV = spaces * m.S':=' * spaces
-- On n'accepte que des noms commenant par une lettre,
-- et composs de lettres, chiffres, souligns et points.
-- On ignore les espaces initiaux.
local name = spaces * m.C(loc.alpha * (loc.alnum + m.S'_.')^0)
-- Les valeurs peuvent tre n'importe quoi,
-- finissant  la fin de la ligne
local value = m.C((1 - sepPairs)^0) * sepPairs^-1
local pair = m.Cg(name * sepNV * value)
-- Motif similaire : on plie les captures,
local props = m.Cf(
        -- Avec pour valeur initiale (premire capture) une table
        -- (cre par une capture de table sur une chane vide)
        m.Ct''
        -- et toutes les paires captures
        * pair^0,
        -- la fonction de pliage tant rawset,
        -- qui aura donc en paramtres  la table (accumulateur),
        -- et la capture groupe, cl, valeur
        rawset)
local propPairs = props:match(properties)
for k, v in pairs(propPairs) do print(k, v) end
--[[ Rsultat :
colour.number  fore:#007F7F
line_eq  y = a * x + b
A42  LtUaE
tabsize  8
use.tabs  1
indent.size  8]]
print "___________________________________"

local message = [[Dans "%0" il y a des '%2' et des '%1']]
local subject = "x = a^2 + b^2"
-- Trouve et capture un gal
local mEq = matchAnywhere(m.C('='))
-- Trouve et capture un exposant
local mExp = matchAnywhere(m.C('^'))
-- Trouve les motifs ci-dessus et consomme le reste de la chane
-- Remplace la chane trouve par le message
local patt = (mEq * mExp * m.P(1)^0) / message
print(m.match(patt, subject))
--> Dans "x = a^2 + b^2" il y a des '^' et des '='
print "___________________________________"

--[[ Experimental feature
local cap = m.R'AZ'
local caps = ((1 - cap) + m.C(cap))^0
local toMatch = "Everybody's Got Something to Hide Except Me and My Monkey"
print(m.match(caps, toMatch))
print(m.match(caps / 1, toMatch))
print "___________________________________"]]

local cap = m.R'AZ'
local toMatch = "Stairway To Heaven"
-- Itre sur la chane, capturant les capitales,
-- remplaant ces dernires  l'aide de la table
local patt = ((1-cap) + m.C(cap) / { H="a", S="L", T="u" })^0
print(m.match(patt, toMatch))
--> L  u  a
print "___________________________________"

local cap = m.R'AZ'
local findCap = ((1 - cap) + m.C(cap))^0
local toMatch = "Harder Better Faster Stronger"
-- Passe toutes les captures  la fonction d'un coup
local patt = findCap / function (a, b, c, d)
    return string.lower(d .. c .. b .. a)
  end
print(m.match(patt, toMatch))
--> sfbh

-- Pour chaque capture trouve (initiales capitales),
-- capture la lettre passe en minuscule
-- Rpte jusqu' la fin de la chane
local patt = ((1 - cap) + m.C(cap) / string.lower)^0
print(m.match(patt, toMatch))
--> h  b  f  s
print "___________________________________"

local digit = m.R'09'
local digit2 = digit * digit
local dateMatch = m.C(digit2) * '/' *
    m.C(digit2) * '/' *
    m.C(digit2 * digit2)

-- Retourne false si la date est incorrecte
function checkDate(day, month, year)
  year = tonumber(year)
  -- Sorties rapides
  if year < 1600 or year > 9999 then return false end
  month = tonumber(month)
  if month < 1 or month > 12 then return false end
  day = tonumber(day)
  if day < 1 or day > 31 then return false end
  if day <= 28 then return true end -- Toujours OK ici
  if month == 2 then
    local isLeapYear = year % 4 == 0 and
        (year % 100 ~= 0 or year % 400 == 0)
    return day == 29 and isLeapYear
  end
  if day == 31 and (month == 4 or month == 6
      or month == 9 or month == 11) then
    return false
  end
  return true
end

function showDateCheck(date)
  print(date, m.match(dateMatch / checkDate, date))
end

-- true
showDateCheck"06/10/1961"
showDateCheck"29/02/2012"
showDateCheck"31/12/2013"
-- false
showDateCheck"01/01/1515"
showDateCheck"01/21/2515"
showDateCheck"41/01/2515"
showDateCheck"31/11/2963"
showDateCheck"29/02/3965"
showDateCheck"30/02/2012"
showDateCheck"29/02/2013"
print "___________________________________"

local digit = m.R'09'
-- Nombre dcimal
local number = digit^1 * m.P'.'^-1 * digit^0
local findPrice = ((1 - digit) + m.C(number))^0
local toMatch = "A : 1.05, B : 2.15, C : 3.14"
print(m.match(findPrice, toMatch)) --> 1.05  2.15  3.14
local applyVAT = m.C(number) / function (p) return p * 1.196 end
local changePrice = ((1 - digit) + applyVAT)^0
print(m.match(m.Cs(changePrice), toMatch))
--> A : 1.2558, B : 2.5714, C : 3.75544

-- Encodage d'URL
local urlEncoding =
{
  [' '] = '+',
  ['!'] = '%21',
  ['#'] = '%23',
  ['$'] = '%24',
  ['&'] = '%26',
  ["'"] = '%27',
  ['('] = '%28',
  [')'] = '%29',
  ['*'] = '%2A',
  ['+'] = '%2B',
  [','] = '%2C',
  ['/'] = '%2F',
  [':'] = '%3A',
  [';'] = '%3B',
  ['='] = '%3D',
  ['?'] = '%3F',
  ['@'] = '%40',
  ['['] = '%5B',
  [']'] = '%5D',
}
local toMatch = "L'adresse est fr@fr.fr, simple !"
local patt = (m.C(1) / urlEncoding)^0
print(m.match(m.Cs(patt), toMatch))
--> L%27adresse+est+fr%40fr.fr%2C+simple+%21
print "___________________________________"


local phpHereDoc =
[[
$document = <<<HEREDOC
Ceci est une chane longue en PHP,
connue sous le nom de
HereDoc;
La chane aprs le <<< est quelconque et
dlimite la fin de la chane.
HEREDOC;
]]
local loc = m.locale()
-- Identificateur
local id = (loc.alnum + '_')^1
-- Retour  la ligne
local newline = m.S'\r\n'^1
-- Marque de heredoc
local hereMark = m.P"<<<"
-- Dbut de heredoc: marque, identificateur, retour  la ligne
-- L'identificateur est captur avec un nom
local hereStart = hereMark * m.Cg(id, "here") * newline
-- Fin de heredoc: retour  la ligne, un identificateur captur,
-- un point-virgule optionnel et un autre retour  la ligne
local hereEnd = newline * m.C(id) * m.P';'^-1 * newline
--~ m.print(hereEnd)
-- Regarde si on est bien  la fin : capture temps-rel
local isEnd = m.Cmt(
    -- Produit la valeur de l'identificateur
    m.Cb"here"
    -- Et concide avec une fin potentielle
    * hereEnd,
    -- La fonction a les paramtres standards,
    -- la valeur de l'id et la fin possible
    function (subject, position, capStart, capEnd)
      -- Montre une concidence rejete (HereDoc) et une OK
      print(capStart, capEnd)
      -- Ne concide que si la fin possible correspond  l'id
      return capEnd == capStart
    end)
-- Le heredoc est cherch (tant qu'on ne trouve pas la marque)
local hereDoc = (1 - hereMark)^0
    -- On concide avec le dbut
    * hereStart
    -- On capture tous les caractres qui ne sont pas la fin
    * m.C((1 - isEnd)^0)
    -- Et on concide avec la fin constate
    * hereEnd
print(hereDoc:match(phpHereDoc))
print "___________________________________"

-- Prend un motif quelconque et le rend capable
-- d'tre cherch n'importe o dans une chane.
function anywhere (p)
  -- Grammaire : soit on trouve le motif, soit, si on choue,
  -- on consomme un caractre et on teste la rgle 1, qui est
  -- celle qu'on vient de voir.
  return   m.P{ p + 1 *   m.V(1) }
end
print "___________________________________"

-- La chane  tester, avec des imbrications d'accolades.
local test = " { a, { b, c, { d }, e, } ; f, {}, \z
  { { g, h } } ; i, { { j }, k, } } "
-- Redfinition des mthodes de LPeg en variables locales :
-- plus rapide (pas critique ici, on n'est pas dans une boucle)
-- et plus concis.
local P, S, C, Ct, V = m.P, m.S, m.C, m.Ct, m.V
-- Dfinitions locales des entits de base : faites en dehors
-- de la grammaire car les rfrences sont moins rapides que
-- des motifs littraux.
local OpenBrace = P'{'
local CloseBrace = P'}'
local Separator = S',;'
local Space = S' \r\n'
local Spaces = Space^0
-- Dfinition de la grammaire
local grammar =
{
  "Start"; --  l'index 1, le nom de la rgle de dpart
  -- Saute les espaces initiaux et finaux
  Start = Spaces * V"Table",
  -- Une table est compose d'une accolade ouvrante,
  -- d'un certain nombre d'lments (ou rien, pour la table vide)
  -- et d'une accolade fermante.
  Table = OpenBrace*Spaces*V"Elements"^-1 * CloseBrace * Spaces,
  -- Une suite d'lments : un lment...
  Elements = V"Element" *
      -- suivi ventuellement d'un sparateur
      -- et d'autre lments, en nombre quelconque
      (Separator * Spaces * V"Element")^0 *
      -- Peut tre suivi d'un sparateur final, et d'espaces
      Separator^-1 * Spaces,
  -- Un lment est une entre de tableau, ou une autre table.
  -- C'est l'lment rcursif de la grammaire.
  Element = V"Table" + V"Unit",
  -- Une entre est une suite de caractres en dehors des
  -- sparateurs et accolades. Primitif mais OK ici.
  Unit = (1-Separator-OpenBrace-CloseBrace-Space)^1 * Spaces,
}
print(P(grammar):match(test)) --> 70
print "___________________________________"

local capturingGrammar =
{
  "Start";
  Start = Spaces * V"Table",
  Table = OpenBrace * Spaces * Ct(V"Elements"^-1)
        * CloseBrace * Spaces,
  Elements = V"Element" *
      (Separator * Spaces * V"Element")^0 *
      Separator^-1 * Spaces,
  Element = V"Table" + V"Unit",
  Unit = C((1 - Separator - OpenBrace - CloseBrace)^1) * Spaces,
}
print "___________________________________"

function reindent(data)
  local indentLevel = 0
  -- On construit la chane en ajoutant ses lments dans une
  -- table et en la concatnant  la fin. C'est plus efficace que
  -- des concatnations successives et a permet de rectifier.
  local t = {}

  -- Ajoute les lments donns  la fin de la table
  local insert = function (...)
    for n = 1, select('#', ...) do
      local v = select(n, ...)
      table.insert(t, v)
    end
  end
  -- Retourne l'indentation courante (squence d'espaces)
  local getIndent = function (il)
    return (' '):rep(indentLevel)
  end
  -- Enlve le dernier lment (sparateur surnumraire)
  local removeLast = function ()
    table.remove(t, #t)
  end

  function dumpObject(obj)
    local indent = getIndent(indentLevel)
    if type(obj) == 'table' then
      -- Dbut d'une table
      insert('\n', indent, '{\n')
      -- On indente
      indentLevel = indentLevel + 1
      insert(getIndent(indentLevel))
      -- Pour chaque objet de la table
      for i, v in ipairs(obj) do
        -- On le restitue de faon rcursive
        dumpObject(v)
      end
      -- Rduction de l'indentation
      indentLevel = indentLevel - 1
      -- On supprime le dernier sparateur
      removeLast()
      -- Et on ferme la table
      insert('\n', indent, '}', ',', '\n', indent)
    else -- Ce n'est pas une table
      -- Ajoute l'lment et un sparateur
      insert(obj, ',')
    end
  end

  dumpObject(data)
  return table.concat(t)
end
print "___________________________________"

-- On passe une grammaire, encore sous forme de table non
-- corrige. Si withIndent est true, la sortie sera indente
-- selon la profondeur dans la grammaire.
function trace(grammar, withIndent)
  -- Niveau d'indentation
  local level = 0
  -- Table des positions o on essaye une rgle
  local lastTry = {}

  -- Pour chaque rgle
  for k, r in pairs(grammar) do

    -- Si son index est un nombre
    if type(k) == "number" then
      -- C'est sans doute la rgle initiale.
      -- Si c'est son nom, on l'affiche.
      -- Ne fonctionne pas avec toutes les styles de grammaire...
      if type(r) ~= "pattern" and type(r) ~= "userdata" then
        print("Initial rule: " .. r)
      end
    else
      -- L'indentation, si elle est demande,  se fait avec
      -- un nombre d'espaces proportionnel au niveau
      local prefix = function (info)
        if withIndent then
          return string.rep(" ", level) .. info
        else
          return info
        end
      end

      -- Motif utilis avant l'essai du vrai motif.
      -- Capture immdiate sur une chane vide, o on rcupre
      -- la chane examine et la position courante.
      local try =   m.P(function (s, p, ...)
        -- On affiche des informations : le nom de la rgle
        -- en cours, la position courante, le caractre qui va
        -- tre essay.
        print(prefix"TRY", k, "AT", p, "WITH",
          "'" .. s:sub(p, p) .. "'")
        -- On monte d'un niveau
        level = level + 1
        -- On mmorise la position courante
        lastTry[level] = p
        -- On continue
        return true
      end)

      -- Motif utilis si le vrai motif a chou.
      local fail =   m.P(function ()
        -- On rduit le niveau
        level = level - 1
        -- On donne l'information, avec la rgle qui a chou
        print(prefix"FAIL", k)
        -- Et on ne va pas plus loin
        return false
      end)

      -- Remplace chaque rgle de la grammaire avec une capture
      -- immdiate qui signale l'essai, tente la rgle
      -- originelle, et si elle choue, signale l'chec.
      grammar[k] =   m.Cmt(try * r + fail,
        -- Pour chaque rgle qui a russi
        function (s, p, ...)
          -- Rcupre la position du dbut de l'essai
          local lt = lastTry[level]
          -- Rduit le niveau
          level = level - 1
          -- Indique la rgle qui a fonctionn, l'endroit atteint
          -- et la portion de texte qui a coincid avec la rgle.
          print(prefix"MATCH", k, "UP TO", p, "=",
            "'" .. s:sub(lt, p-1) .. "'")
          -- Affiche aussi la chane d'entre
          -- qui a coincid jusqu'ici.
          print("-->", "'" .. s:sub(1, p-1) .. "'")
          -- Et continue.
          return true
        end)

    end
  end
  -- Retourne la grammaire ainsi trafique
  return grammar
end
print "___________________________________"

local OpenBrace = P'{'
local CloseBrace = P'}'
local Separator = S',;'
local Space = S' \r\n'
local Spaces = Space^0
-- Dfinition de la grammaire
local grammar =
{
  "Start";
  Start = Spaces * V"Table",
  Table = OpenBrace*Spaces*V"Elements"^-1 * CloseBrace * Spaces,
  Elements = V"Element" *
      (Separator * Spaces * V"Element")^0 *
      Separator^-1 * Spaces,
  Element = V"Table" + V"Unit",
  Unit = (1 - Separator - OpenBrace - CloseBrace)^1 * Spaces,
}
print "___________________________________"

local grammar =
{
  "Start";
  OpenBrace = P'{',
  CloseBrace = P'}',
  Separator = S',;',
  Space = S' \r\n',
  Spaces = V'Space'^0,
  Start = V'Spaces' * V"Table",
  Table = V'OpenBrace' * V'Spaces' * V"Elements"^-1
        * V'CloseBrace' * V'Spaces',
  Elements = V"Element" *
      (V'Separator' * V'Spaces' * V"Element")^0 *
      V'Separator'^-1 * V'Spaces',
  Element = V"Table" + V"Unit",
  Unit = (1 - V'Separator' - V'OpenBrace' - V'CloseBrace'
       - V'Space')^1 * V'Spaces',
}
print "___________________________________"
